(function(){
  var ref$, filter, find, map, partition, reverse, sortBy, clamp, findAll, partitionString, remove, exports;
  ref$ = require('prelude-ls'), filter = ref$.filter, find = ref$.find, map = ref$.map, partition = ref$.partition, reverse = ref$.reverse, sortBy = ref$.sortBy;
  clamp = function(n, min, max){
    return Math.max(min, Math.min(max, n));
  };
  findAll = function(text, search, offset, indices){
    var index;
    offset == null && (offset = 0);
    indices == null && (indices = []);
    index = text.substr(offset).indexOf(search);
    if (index === -1) {
      return indices;
    }
    return findAll(text, search, offset + index + search.length, indices.concat([offset + index]));
  };
  partitionString = function(text, search){
    var indices, first, x, last, high, low;
    if (search.length === 0) {
      return [[0, text.length]];
    }
    indices = findAll(text, search), first = indices[0], x = indices[indices.length - 1];
    if (indices.length === 0) {
      return [];
    }
    last = x + search.length;
    high = map(function(it){
      return [it, it + search.length, true];
    })(
    indices);
    low = map(function(i){
      return [high[i][1], high[i + 1][0], false];
    })(
    (function(){
      var i$, to$, results$ = [];
      for (i$ = 0, to$ = high.length - 1; i$ < to$; ++i$) {
        results$.push(i$);
      }
      return results$;
    }()));
    return (first === 0
      ? []
      : [[0, first, false]]).concat(sortBy(function(it){
      return it[0];
    })(
    high.concat(low)), last === text.length
      ? []
      : [[last, text.length, false]]);
  };
  remove = curry$(function(f, c){
    return function(it){
      return it[1];
    }(
    partition(f)(
    c));
  });
  exports = module.exports = {
    clamp: clamp,
    findAll: findAll,
    partitionString: partitionString,
    remove: remove
  };
  function curry$(f, bound){
    var context,
    _curry = function(args) {
      return f.length > 1 ? function(){
        var params = args ? args.concat() : [];
        context = bound ? context || this : this;
        return params.push.apply(params, arguments) <
            f.length && arguments.length ?
          _curry.call(context, params) : f.apply(context, params);
      } : f;
    };
    return _curry();
  }
}).call(this);
